<?php
/*
 * modified by Jockl
 * http://forum.mybboard.de/user-2693.html
 * 
 * Version 1.06
 *
 * version for hkkp
 * not Bot-ID but user-id who has bumped the thread
 *
 * Version 1.05
 *
 * Bump Button in postbit and postbit_classic instead of showthread
 * bump enabled in specific forums only
 *
 * Version 1.04
 * inlinecheck for moderation included
 *
 * Version 1.03
 * according: http://forum.mybboard.de/thread-29854.html  
 *
*/
//error_reporting(E_ALL);
$plugins->add_hook('datahandler_post_insert_post', 'bumpthread_postbit_newpost');
$plugins->add_hook('datahandler_post_insert_thread', 'bumpthread_postbit_newthread');
$plugins->add_hook('postbit', 'bumpthread_postbit_postbit');
$plugins->add_hook('showthread_start', 'bumpthread_postbit_checkbump');
$plugins->add_hook('forumdisplay_start', 'bumpthread_postbit_foruminject');

function bumpthread_postbit_info()
{
	return array(
		'name'			=> 'Bump Thread via postbit',
		'description'	=> 'Allows users to bump their own threads without posting via postbit.',
		'website'		=> 'http://mybbhacks.zingaburga.com/',
		'author'		=> 'ZiNgA BuRgA',
		'authorsite'	=> 'http://zingaburga.com/',
		'version'		=> '1.06',
		'compatibility'	=> '16*'
	);
}

function bumpthread_postbit_install()
{
	global $db;
  
	$db->query('ALTER TABLE '.TABLE_PREFIX.'threads ADD (
		`lastpostbumps` BIGINT(30) UNSIGNED NOT NULL DEFAULT 0
	)');
  
	$db->query('UPDATE '.TABLE_PREFIX.'threads SET lastpostbumps=lastpost');
	
	// add settings
	$settings_gid = $db->insert_query('settinggroups', array(
		'name' => 'bumpthread_postbit',
		'title' => 'Bump Thread Options',
        'description' => 'Allows users to bump their own threads without posting via postbit.',
		'disporder' => 50,
	));
  
	$db->insert_query('settings', array(
		'name' => 'bumpthread_postbit_interval',
		'optionscode' => 'text',
		'value' => 30,
		'title' => 'Time Between Bumps',
		'description' => 'The time (in minutes) a user must wait before they are allowed to (re) bump their thread.',
		'disporder' => 1,
		'gid' => $settings_gid
	));

  	$db->insert_query('settings', array(
		'name' => 'bumpthread_postbit_fid',
		'optionscode' => 'text',
		'value' => '2,35',
		'title' => 'Forum-IDs',
		'description' => 'Enter Forum-IDs, where threads are not allowed to be pushed. Seperate fids with comme.',
		'disporder' => 2,
		'gid' => $settings_gid
	));

  	$db->insert_query('settings', array(
		'name' => 'bumpthread_postbit_message',
		'optionscode' => 'text',
		'value' => '--- Thread pushed ---',
		'title' => 'Message',
		'description' => 'Message of the post',
		'disporder' => 3,
		'gid' => $settings_gid
	));

	rebuild_settings();  
}

function bumpthread_postbit_uninstall()
{	
	global $db;

	$db->query("ALTER TABLE ".TABLE_PREFIX."threads DROP `lastpostbumps`");
	$db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name='bumpthread_postbit'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='bumpthread_postbit_interval'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='bumpthread_postbit_message'");
    $db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='bumpthread_postbit_fid'");

	rebuild_settings();
}

function bumpthread_postbit_is_installed()
{
  global $db, $settings;
	
	$query = $db->simple_select("settinggroups", "*", "name='bumpthread_postbit'");
	$setting_group = $db->fetch_array($query);

    if($setting_group)
    {
        return true;
    }

    return false;
}

function bumpthread_postbit_activate()
{
	global $db;
	
	require MYBB_ROOT."/inc/adminfunctions_templates.php";

	find_replace_templatesets('postbit', '#'.preg_quote('$post[\'button_delete_pm\']}').'#', '$post[\'button_delete_pm\']}{$post[\'bumpthread\']}');
	find_replace_templatesets('postbit_classic', '#'.preg_quote('$post[\'button_delete_pm\']}').'#', '$post[\'button_delete_pm\']}{$post[\'bumpthread\']}');


	$new_template = ' <a href="showthread.php?tid={$tid}&amp;action=bump" class="bump_button_postbit">Bump This Thread</a>';
	$db->insert_query('templates', array(
		'title' => 'bumpthread_postbit',
		'template' => $db->escape_string($new_template),
		'sid' => -1,
		'version' => 160
	));
  
	// css-class for Bump-Thread Button	
	$css = array(
	"name" => "bumpthread_postbit_button.css",
	"tid" => 1,
	"attachedto" => "showthread.php",
	"stylesheet" => ".bump_button_postbit{
	background-color:#026CB1;
	-moz-border-radius:3px;
	-webkit-border-radius:3px;
	border-radius:3px;
	border:1px solid #026CB1;
	display:inline-block;
	color:#fff !important;
	font-family:arial;
	font-size:12px;
	font-weight:bold;
	padding:0px 2px 0px 2px;
	text-decoration:none;
	vertical-align:5px;
}",
    "cachefile" => $db->escape_string(str_replace('/', '', bumpthread_postbit_button.css)),
	"lastmodified" => TIME_NOW
	);

	require_once MYBB_ADMIN_DIR."inc/functions_themes.php";

	$sid = $db->insert_query("themestylesheets", $css);
	$db->update_query("themestylesheets", array("cachefile" => "css.php?stylesheet=".$sid), "sid = '".$sid."'", 1);

	$tids = $db->simple_select("themes", "tid");
	while($theme = $db->fetch_array($tids))
	{
		update_theme_stylesheet_list($theme['tid']);
	}
}

function bumpthread_postbit_deactivate()
{
	global $db;
  
	require MYBB_ROOT."/inc/adminfunctions_templates.php";

	find_replace_templatesets('postbit', '#'.preg_quote('{$post[\'bumpthread\']}').'#', '', 0);
    find_replace_templatesets('postbit_classic', '#'.preg_quote('{$post[\'bumpthread\']}').'#', '', 0);

	$db->delete_query('templates', 'title = "bumpthread_postbit"');
  
	$db->delete_query("themestylesheets", "name = 'bumpthread_postbit_button.css'");

	require_once MYBB_ADMIN_DIR."inc/functions_themes.php";

	$query = $db->simple_select("themes", "tid");
	while($theme = $db->fetch_array($query))
	{
		update_theme_stylesheet_list($theme['tid']);
	}
}

function bumpthread_postbit_newpost(&$ph)
{
	global $db, $post;
	$db->update_query('threads', array('lastpostbumps' => TIME_NOW), 'tid='.$ph->data['tid']);
}

function bumpthread_postbit_newthread(&$ph)
{
	$ph->thread_insert_data['lastpostbumps'] = $ph->data['dateline'];
}

function bumpthread_postbit_foruminject()
{
	global $db;
	eval('
		class BumpThreadDummyDB extends '.get_class($db).'
		{
			function BumpThreadDummyDB(&$olddb)
			{
				$vars = get_object_vars($olddb);
				foreach($vars as $var => $val)
					$this->$var = $val;
			}
			
			function query($string, $hideerr=0)
			{
				$string = str_replace(\'t.lastpost\', \'t.lastpostbumps\', $string);
				return parent::query($string, $hideerr);
			}
		}
	');
	$db = new BumpThreadDummyDB($db);
	
}

function bumpthread_postbit_checkbump(&$post)
{
    global $mybb, $thread, $tid, $db;


	if($mybb->input['action'] == 'bump')
	{
		if($mybb->usergroup['cancp'] != 1 && $mybb->usergroup['issupermod'] != 1 && $thread['uid'] != $mybb->user['uid'])
		{
			error_no_permission();
		}

		if($thread['lastpostbumps'] + intval($mybb->settings['bumpthread_postbit_interval'])*60 > TIME_NOW)
		{
			error('You cannot bump this thread within '.intval($mybb->settings['bumpthread_postbit_interval']).' minute(s) of its last bump.');
		}

		$db->update_query('threads', array('lastpostbumps' => TIME_NOW), 'tid='.$thread['tid']);

		//$bot_uid = $mybb->settings['bumpthread_postbit_uid'];
		$bot_uid = $mybb->user['uid'];

		$query = $db->simple_select("users","username","uid =".$bot_uid."");
		$query = $db->fetch_array($query);

		$bot_name = $query['username'];

		require_once MYBB_ROOT.'inc/class_parser.php';
		$parser = new postParser;

		$message = $db->escape_string($mybb->settings['bumpthread_postbit_message']);
		$message  = $parser->parse_message($message);

		$query = $db->simple_select("posts","pid,tid,fid,subject,icon","tid =".$tid."");
		$query = $db->fetch_array($query);

		require_once MYBB_ROOT."inc/datahandlers/post.php";
		$posthandler = new PostDataHandler("insert");

		$post = array(
			"tid" => $tid,
			"replyto" => "0",
			"fid" => $query['fid'],
			"subject" => "RE: ".$query['subject'],
			"icon" => $query['icon'],
			"uid" => $bot_uid,
			"username" => $bot_name,
			"dateline" => TIME_NOW + 1, // Increase time to set the lastpost correctly
			"message" => $message,
			"ipaddress" => get_ip(),
			"posthash" => $mybb->input['posthash']
		);

		if($mybb->input['pid'])
		{
			$post['pid'] = $mybb->input['pid'];
		}

		$posthandler->set_data($post);
		$valid_post = $posthandler->validate_post();

		if(!$valid_post)
		{
			$post_errors = $posthandler->get_friendly_errors();
		}
		$postinfo = $posthandler->insert_post();

		$last_thread = array(
			"lastposter" => $bot_name,
			"lastposteruid" => $bot_uid
		);

		$db->update_query("threads", $last_thread, "tid = '".$tid."'");

		$last_forum = array(
			"lastposter" => $bot_name,
			"lastposteruid" => $bot_uid
		);

		$db->update_query("forums", $last_forum, "fid = '".$tid."'");

			redirect('showthread.php?tid='.$thread['tid'].'&action=lastpost', 'Thread Bumped');
	}
	else
	{
        $query = $db->simple_select("posts","fid","tid =".$tid."");
		$query = $db->fetch_array($query);
		$bump_disable_fid = explode(",", $mybb->settings['bumpthread_postbit_fid']);

		if(!in_array($query['fid'],$bump_disable_fid))
		{
			// eval bump
			if($mybb->usergroup['cancp'] == 1 || $mybb->usergroup['issupermod'] == 1 || $thread['uid'] == $mybb->user['uid'])
			{
				global $bumpthread, $templates, $tid, $db;

	            $query = $db->simple_select('threads', 'lastpostbumps', 'tid='.$thread['tid']);
				$result = $db->fetch_array($query);

				// show button when it is allowed to push the thread
				if($thread['lastpostbumps'] && (TIME_NOW - $mybb->settings['bumpthread_postbit_interval']*60) >= $result['lastpostbumps']){
	   				eval('$post[\'bumpthread\'] = "'.$templates->get('bumpthread_postbit').'";');
				}
			}
		}
   }
}

function bumpthread_postbit_postbit(&$post)
{
	global $db, $mybb, $ismod, $templates, $lang, $postcounter, $tid, $thread;

    bumpthread_postbit_checkbump($post);

	if($post['uid'] == $mybb->user['uid'] && $post['message'] == $mybb->settings['bumpthread_postbit_message'])
	{
		$post['message'] = $post['message']."<span style=\"padding-left:25px;\">".$post['postdate'].": ".$post['posttime']."</span>";

	    $post['editedmsg'] = "";
	    //$post['profilelink'] = "";
	    $post['posturl'] = "";
	    $post['useravatar'] = "";
	    $post['onlinestatus'] = "";
	    $post['usertitle'] = "";
	    $post['userstars'] = "";
	    $post['groupimage'] = "";
	    $post['user_details'] = "";
	    $post['icon'] = "";
	    $post['subject'] = "";
	    $post['subject_extra'] = "";
	    $post['attachments'] = "";
	    $post['signature'] = "";
	    $post['iplogged'] = "";
	    $post['button_email'] = "";
	    $post['button_pm'] = "";
	    $post['button_www'] = "";
	    $post['button_find'] = "";
	    $post['button_rep'] = "";
	    $post['button_edit'] = "";
	    $post['button_quickdelete'] = "";
	    $post['button_quote'] = "";
	    $post['button_multiquote'] = "";
	    $post['button_report'] = "";
	    $post['button_warn'] = "";
	    $post['button_reply_pm'] = "";
	    $post['button_replyall_pm'] = "";
	    $post['button_forward_pm'] = "";
	    $post['button_delete_pm'] = "";
  	}

	// Inline moderation stuff
	if($ismod)
	{
		if(isset($mybb->cookies[$inlinecookie]) && my_strpos($mybb->cookies[$inlinecookie], "|".$post['pid']."|"))
		{
			$inlinecheck = "checked=\"checked\"";
			$inlinecount++;
		}
		else
		{
			$inlinecheck = "";
		}

		eval("\$post['inlinecheck'] = \"".$templates->get("postbit_inlinecheck")."\";");

		if($post['visible'] == 0)
		{
			$invisiblepost = 1;
		}
	}
	else
	{
		$post['inlinecheck'] = "";
	}

	$post['postlink'] = get_post_link($post['pid'], $post['tid']);
	eval("\$post['posturl'] = \"".$templates->get("postbit_posturl")."\";");

  return $post;
}
?>